clear, clc, mode(0), close(winsid()) 
/// Odhad ze simulace modelu $y_t=b_0u_t +a_1y_{t-1}+b_1u_{t-1}+a_2y_{t-2}+b_2u_{t-2}+e_t$

//////////////Simulace
nd=100;              //počet dat

theta=[1 0.6 -1.5 0.1 0.2]; // vektor regresních koeficientů
r=0.01;           // rozptyl

u=sqrt(3)*rand(1,nd,'n')+7; //řídící vstup s normálním rozdělením se střední hodnotou 7
//u=7*ones(1,nd); // jednotkový skok

y=zeros(1,nd);  //počáteční podmínky
for t=3:nd
    ps=[u(t) y(t-1)  u(t-1) y(t-2)  u(t-2)];  //regresní vektor
    y(t)=theta*ps'+sqrt(r)*rand(1,1,'n');//generování vystupu 
end


//////////////////////Odhadování 
nps=length(ps)+1;    //rozměr informační matice V
V=0.01*eye(nps,nps);    //počáteční informační matice V
k=0;                 //počáteční počítadlo k

for t=3:nd
    Ps=[y(t) u(t) y(t-1)  u(t-1) y(t-2)  u(t-2)];//rozšířený regresní vektor
    V=V+Ps'*Ps;        //update statistiky V 
    k=k+1;             //update statistiky k 
end


//rozklad informační matice V
Vy=V(1,1);        // část Vy 
Vyps=V(2:$,1);   // část Vyps
Vps=V(2:$,2:$);  //část Vps





//bodové odhady
theta_odhad=inv(Vps)*Vyps;      //bodové odhady regresních koeficientů
r_odhad=(Vy-Vyps'*inv(Vps)*Vyps)/k; //bodový odhad rozptylu




////////////Simulace s odhadem parametrů pro predikci výstupu
yp=zeros(1,nd); //počáteční predikce
for t=3:nd
    ps=[u(t) yp(t-1)  u(t-1) yp(t-2)  u(t-2)];  //regresní vektor s predikcí
    yp(t)=ps*theta_odhad+sqrt(r_odhad)*rand(1,1,'n');//generování predikce 
end

////výsledky
disp('Skutečné regresní koeficienty',theta')
disp('Odhad regresních koeficientů',theta_odhad)
disp('Rozptyl',r)
disp('Odhad rozptylu',r_odhad)


plot(y,'b-*','Markersize',10)
plot(yp,'r-')
legend('Simulace','Predikce');
title('Odhad s regresním modelem 2.řádu','fontsize',5)
ylabel('Data','fontsize',5)
xlabel('Čas','fontsize',5)


