clear, clc, mode(0), close(winsid()) 
/// Odhad regresního modelu $y_t=b_0v_{1;t}+c_0v_{2;t}+a_1y_{t-1}+b_1v_{1;t-1}+c_1v_{2;t-1}+a_2y_{t-2}+k+e_t$

load dataRychlost.sod;
y=rychlost; //// rychlost auta v koloně ve městě
v1=rychPred; //// rychlost vpředu jedoucího vozidla
v2=vzdal; //// vzdálenost mezi vozidly

nd=size(y,1);   /// počet dat


//////////////////////Odhadování 
nps=7+1;    //rozměr informační matice V
V=zeros(nps,nps);    //počáteční informační matice V
k=0;                 //počáteční počítadlo k

for t=3:nd
    Ps=[y(t) v1(t) v2(t) y(t-1) v1(t-1) v2(t-1) y(t-2) 1];//rozšířený regresní vektor
    V=V+Ps'*Ps;        //update statistiky V 
    k=k+1;             //update statistiky k 
end
//rozklad informační matice V
Vy=V(1,1);        // část Vy 
Vyps=V(2:$,1);   // část Vyps
Vps=V(2:$,2:$);  //část Vps

//bodové odhady
theta_odhad=inv(Vps)*Vyps;      //bodové odhady regresních koeficientů
r_odhad=(Vy-Vyps'*inv(Vps)*Vyps)/k; //bodový odhad rozptylu




////////////Simulace s odhadem parametrů pro predikci výstupu
yp(1)=1; yp(2)=1; //počáteční predikce // 45

for t=3:nd
    ps=[v1(t) v2(t) yp(t-1) v1(t-1) v2(t-1) yp(t-2) 1];  //regresní vektor s predikcí
    yp(t)=ps*theta_odhad+sqrt(r_odhad)*rand(1,1,'n');//generování predikce 
end






////výsledky
disp('Odhad regresních koeficientů',theta_odhad)
disp('Odhad rozptylu',r_odhad)

plot(y(1:nd),'b-')
plot(yp,'r-')
legend('Rychlost','Predikce',4);
title('Rychlost auta v koloně ve městě','fontsize',5)
ylabel('Rychlost','fontsize',5)
xlabel('Čas','fontsize',5)
